#pragma once
#include "Sine.h"

class CMultiSine
{
public:
	CMultiSine(void);
	~CMultiSine(void);

	// array of four
	CSine sineArray[4];

	// set them up
	inline void setSampleRate(float fSampleRate)
	{
		sineArray[0].m_fSampleRate = fSampleRate;
		sineArray[1].m_fSampleRate = fSampleRate;
		sineArray[2].m_fSampleRate = fSampleRate;
		sineArray[3].m_fSampleRate = fSampleRate;
	}

	//
	inline void reset()
	{
		sineArray[0].reset();
		sineArray[1].reset();
		sineArray[2].reset();
		sineArray[3].reset();
	}

	inline void setFo(float fo)
	{
		sineArray[0].setFo(fo);
		sineArray[1].setFo(2*fo);
		sineArray[2].setFo(3*fo);
		sineArray[3].setFo(4*fo);
	}

	inline float doOscillate()
	{
		return 0.25*sineArray[0].doOscillate() + 0.25*sineArray[1].doOscillate() + 0.25*sineArray[2].doOscillate() + 0.25*sineArray[3].doOscillate();
	}
};
